﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Configuration;

using Factonomy.AzureStorageUtility.WindowsApp.Resources;

namespace Factonomy.AzureStorageUtility.WindowsApp.UI.Forms
{
    public partial class AddNewFile : Form
    {
        public delegate void MyAddFileDelegate(string fileName, string blobName);
        public event MyAddFileDelegate AddFile;

        protected void OnAddFile(string message, string root)
        {
            if (AddFile != null)
            {
                AddFile(message, root);
            }
        }

        public AddNewFile()
        {
            InitializeComponent();

            // set the window icon
            this.Icon = ResourceManager.GetAppIcon();

            this.uiButtonAdd.Click += new EventHandler(uiButtonAdd_Click);
            this.uiButtonCancel.Click += new EventHandler(uiButtonCancel_Click);
            this.uiButtonSelectFile.Click += new EventHandler(uiButtonSelectFile_Click);
            this.uiTexboxRoot.Text = ConfigurationManager.AppSettings["rootpath"];
            this.uiTexboxRoot.TextChanged += new EventHandler(UpdateBlobNamePreview);
            this.uiTextboxFileName.TextChanged += new EventHandler(UpdateBlobNamePreview);

            this.uiLabelBlobName.Text = string.Empty;
        }

        private void UpdateBlobNamePreview(object sender, EventArgs e)
        {
            this.uiLabelBlobName.Text = this.uiTextboxFileName.Text.Replace(this.uiTexboxRoot.Text, "");
        }

        void uiButtonSelectFile_Click(object sender, EventArgs e)
        {
            using (OpenFileDialog openFileDialog1 = new OpenFileDialog())
            {
                openFileDialog1.InitialDirectory = this.uiTexboxRoot.Text;
                openFileDialog1.RestoreDirectory = true;

                if (openFileDialog1.ShowDialog() == DialogResult.OK)
                {
                    this.uiTextboxFileName.Text = openFileDialog1.FileName;
                    this.UpdateBlobNamePreview(null, null);
                }
            }
        }

        void uiButtonCancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        void uiButtonAdd_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("Are you sure you want to add " + this.uiLabelBlobName.Text + "?", "Confirm Add", MessageBoxButtons.YesNo) == DialogResult.Yes)
            {
                this.OnAddFile(this.uiTextboxFileName.Text, this.uiLabelBlobName.Text);
                this.Close();
            }
        }
    }
}
