﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Factonomy.AzureUtility.Core
{
    class Globals
    {
        public static bool IsText(string contentType, string extension)
        {
            switch (extension)
            {
                case ".config":
                    return true;
                case ".rtf":
                    return true;
                case ".txt":
                    return true;
                case ".xsd":
                    return true;
                case ".xsl":
                    return true;
                case ".xslt":
                    return true;
                case ".xml":
                    return true;
                case ".css":
                    return true;
                case ".js":
                    return true;
                default:
                    return false;
            }
        }

        public static bool IsImage(string contentType, string extension)
        {
            return contentType.StartsWith("image/");
        }

        public static bool IsAudio(string contentType, string extension)
        {
            return false;
        }

        public static bool IsVideo(string contentType, string extension)
        {
            switch (extension)
            {
                case ".wmv":
                    return true;
                case ".mov":
                    return true;
                default:
                    return false;
            }
        }

        public static string GetHttpContentType(string extension)
        {
            switch (extension)
            {
                case ".dot":
                    return "application/msword";
                case ".doc":
                    return "application/msword";
                case ".avi":
                    return "video/avi";
                case ".mov":
                    return "video/quicktime";
                case ".mp3":
                    return "audio/mpeg3";
                case ".mpp":
                    return "video/mp4";
                case ".pps":
                    return "application/mspowerpoint";
                case ".rtf":
                    return "application/rtf";
                case ".tif":
                    return "image/tiff";
                case ".txt":
                    return "plain/text";
                case ".wav":
                    return "audio/wav";
                case ".xls":
                    return "application/excel";
                case ".zip":
                    return "application/zip";
                case ".xsd":
                    return "text/xml";
                case ".xsl":
                    return "application/xml";
                case ".xslt":
                    return "application/xml";
                case ".xml":
                    return "text/xml";
                case ".css":
                    return "text/css";
                case ".bmp":
                    return "image/bmp";
                case ".gif":
                    return "image/gif";
                case ".jpeg":
                    return "image/jpeg";
                case ".jpg":
                    return "image/jpeg";
                case ".png":
                    return "image/png";
                case ".x-png":
                    return "image/png";
                case ".js":
                    return "application/x-javascript";
                case ".pdf":
                    return "application/pdf";
                case ".ico":
                    return "image/x-icon";
                case ".flv":
                    return "video/x-flv";
                case ".wmv":
                    return "audio/x-ms-wmv";
                case ".swf":
                    return "application/x-shockwave-flash";
                default:
                    return "text/html";
            }
        }
    }
}
